#ifndef _NAMES_
#define _NAMES_

#ifndef _TYPES_
#include "cctypes.h"
#endif

#define VECTOR_ELEMENT_SIZE		32
#define VECTOR_ELEMENT_MASK		31
#define LOG_VECTOR_ELEMENT_SIZE 5

#define vector_elem(n)		((n)>>LOG_VECTOR_ELEMENT_SIZE)
#define vector_bit(n)		(((U_INT32)1)<< ((n) & VECTOR_ELEMENT_MASK))

#define bit(n)				((unsigned)1<<(n))
#define clear_bit			&= ~
#define set_bit				|=
#define is_bit_set			&

#define set_vector_bit(vector,bit)		(vector)[(bit)>>LOG_VECTOR_ELEMENT_SIZE]|=	(((U_INT32)1)<<((bit)&VECTOR_ELEMENT_MASK))
#define clear_vector_bit(vector,bit)	(vector)[(bit)>>LOG_VECTOR_ELEMENT_SIZE]&=~	(((U_INT32)1)<<((bit)&VECTOR_ELEMENT_MASK))
#define is_vector_bit_set(vector,bit)	((vector)[(bit)>>LOG_VECTOR_ELEMENT_SIZE]&	(((U_INT32)1)<<((bit)&VECTOR_ELEMENT_MASK)))

#define max(n1,n2) ((n1) > (n2) ? (n1) : (n2))
#define min(n1,n2) ((n1) < (n2) ? (n1) : (n2))

#define KILOBYTE		1024
#define MAX_VECTOR_SIZE 16
#define IO_BUF_SIZE		8*KILOBYTE
#define WORD_SIZE		4
#define MAX_CHECK_SIZE	256				/* 1K maximal to allow stack shrinking */
#define SMALL_CONSTANT	65536			/* 'small' for arithmetic opts (like prod) */

#define init_string(s,chars)			{s.length=0;s.string=chars;}

#define is_print_char(c)				((int)(c)>=32 && (int)(c)<=126 && (int)(c) != 34)
#define is_digit(c)						((unsigned)((c)-'0')<(unsigned)10)
#define is_white(c)						((c) == ' ' || (c) == '\t' || (c) == '\n')

#endif