#ifndef _SIGNALS_
#define _SIGNALS_

/*	these signal numbers depend on the runtime system. Usually these signals are
	used implicitly in library routines, but some of them are also inserted by
	the code generator explicitly */

typedef enum SIGNAL_NUMBER
{
										/* 0 not used						*/
	S_COLLECT				=1,			/* perform garbage collection		*/
	S_DEBUGGER				=2,			/* call debugger					*/
	S_ASYNC_MESSAGE			=3,			/* insert message from heap			*/
	S_SYNC_MESSAGE			=4,			/* insert message from heap			*/
	S_GCOPY					=5,			/* make global copy of graph		*/
	S_LCOPY					=6,			/* make local copy of graph			*/
	S_GLOBAL_NODE			=7,			/* get global address for node		*/
	S_ERROR					=8,			/* signal an error					*/
	S_REMOVE_POINTER		=9,			/* remove global pointer			*/
	S_INIT_REDUCER			=10,			/* initialise a new reducer			*/
	S_INIT_REDUCER2			=11,		/* initialise off-chip reducer		*/
	S_RELEASE_LOCAL			=12,		/* release local waiting list		*/
	S_PROC_AT_DIST			=13			/* get proc id at given distance	*/
	
} SIGNAL_NUMBER;

#endif