
#ifndef _TYPES_
#define _TYPES_

#define _COMPILE_UNUSED_	0

#include <stdlib.h>
#include <stdio.h>

#ifndef _OFFSETS_
#include "ccoffsets.h"
#endif

/************************************************************************************
 *																					*
 *		basic types	(part 1)														*
 *																					*
 ************************************************************************************/

#define ANSI_C

/************************************************************************************
 *																					*
 *		THINK C types																*
 *																					*
 ************************************************************************************/

#ifdef THINK_C

#define MACINTOSH

#define word_align(size)	size=(size+3)&~3

typedef void			VOID;						/* normal void					*/
typedef unsigned short	BOOL;						/* at least 1 bit unsigned		*/
typedef char			BYTE;						/* at least 8 bits signed		*/
typedef unsigned char	U_BYTE;						/* at least 8 bits unsigned		*/
typedef char			CHAR;						/* one signed character			*/
typedef unsigned char	U_CHAR;						/* one unsigned character		*/
typedef int				INT16;						/* at least 16 bits signed		*/
typedef unsigned int	U_INT16;					/* at least 16 bits unsigned	*/
typedef long			INT32;						/* 32 bits signed				*/
typedef	unsigned long	U_INT32;					/* 32 bits unsigned				*/
typedef short double	DOUBLE;						/* 64 bits float				*/

#define VARIABLE_ARRAY_SIZE
#define VAR_ARGS		...

typedef VOID			*POINTER;

#define MAXINT32		LONG_MAX
#define MAXINT16		INT_MAX
#define MININT32		LONG_MIN
#define MININT16		INT_MIN

#define next_short(argp)	va_arg(argp,INT16)
#define next_string(argp)	va_arg(argp,CHAR *)

/*	the following routines are needed to store some values at non-aligned
	addresses. This is not so important for the Mac, but it is for the
	sparc.
*/

#define put_int16(p,i)	{*(INT16 *)p=i;p+=sizeof(INT16);}
#define get_int16(p,i)	{i=*(INT16 *)p;p+=sizeof(INT16);}

typedef long			FTYPE;
typedef long			FCREATOR;
typedef long			PTYPE;

#endif

/****************************************************************************************
 *																						*
 *		Metrowerks types																*
 *																						*
 ****************************************************************************************/

#if __MWERKS__

#define MACINTOSH

#ifdef powerc
#define POWERPC
#endif

#define word_align(size)	size=(size+3)&~3

typedef void			VOID;						/* normal void					*/
typedef unsigned short	BOOL;						/* at least 1 bit unsigned		*/
typedef char			BYTE;						/* at least 8 bits signed		*/
typedef unsigned char	U_BYTE;						/* at least 8 bits unsigned		*/
typedef char			CHAR;						/* one signed character			*/
typedef unsigned char	U_CHAR;						/* one unsigned character		*/

#ifdef POWERPC
	typedef long			INT16;					/* at least 16 bits signed		*/
	typedef unsigned long	U_INT16;				/* at least 16 bits unsigned	*/
#else
	typedef int				INT16;					/* at least 16 bits signed		*/
	typedef unsigned int	U_INT16;				/* at least 16 bits unsigned	*/
#endif

typedef long			INT32;						/* 32 bits signed				*/
typedef	unsigned long	U_INT32;					/* 32 bits unsigned				*/
typedef short double	DOUBLE;						/* 64 bits float				*/

#define VARIABLE_ARRAY_SIZE
#define VAR_ARGS		...

typedef VOID			*POINTER;

#define MAXINT32		LONG_MAX
#define MININT32		LONG_MIN

#ifdef POWERPC
	#define MAXINT16		LONG_MAX
	#define MININT16		LONG_MIN
#else
	#define MAXINT16		INT_MAX
	#define MININT16		INT_MIN
#endif

#define next_short(argp)	va_arg(argp,INT16)
#define next_string(argp)	va_arg(argp,CHAR *)

/*	the following routines are needed to store some values at non-aligned
	addresses. This is not so important for the Mac, but it is for the
	sparc.
*/

#define put_int16(p,i)	{*(INT16 *)p=i;p+=sizeof(INT16);}
#define get_int16(p,i)	{i=*(INT16 *)p;p+=sizeof(INT16);}

typedef long			FTYPE;
typedef long			FCREATOR;
typedef long			PTYPE;

#endif

/************************************************************************************
 *																					*
 *		GNU C types																	*
 *																					*
 ************************************************************************************/

#ifdef GNU_C

#define word_align(size)	size=(size+7)&~7

typedef void			VOID;						/* normal void					*/
typedef unsigned short	BOOL;						/* at least 1 bit unsigned		*/
typedef char			BYTE;						/* at least 8 bits signed		*/
typedef unsigned char	U_BYTE;						/* at least 8 bits unsigned		*/
typedef char			CHAR;						/* one signed character			*/
typedef unsigned char	U_CHAR;						/* one unsigned character		*/
typedef short			INT16;						/* at least 16 bits signed		*/
typedef unsigned short	U_INT16;					/* at least 16 bits unsigned	*/
typedef int				INT32;						/* 32 bits signed				*/
typedef	unsigned int	U_INT32;					/* 32 bits unsigned				*/
typedef double			DOUBLE;						/* 64 bits unsigned				*/

#define VARIABLE_ARRAY_SIZE	0
#define VAR_ARGS

typedef VOID			*POINTER;

#define MAXINTEGER		INT_MAX
#define MAXSHORT		SHORT_MAX

#define next_short(argp)	va_arg(argp,int)
#define next_string(argp)	va_arg(argp,CHAR *)

#define put_int16(p,i)		{*(U_CHAR *)p=(U_CHAR)((U_INT16)i>>8);*(U_CHAR *)(p+1)=(U_CHAR)i;p+=2;}
#define get_int16(p,i)		{i=(INT16)((*(U_CHAR *)p<<8) | *(U_CHAR *)(p+1));p+=2;}

#define SEEK_SET		0
#define SEEK_CUR		1
#define SEEK_END		2

#endif

/************************************************************************************
 *																					*
 *		PACT Parallel C types														*
 *																					*
 ************************************************************************************/

#ifdef __PACT__

#define word_align(size)	size=(size+3)&~3

typedef void			VOID;						/* normal void					*/
typedef unsigned int	BOOL;						/* at least 1 bit unsigned		*/
typedef char			BYTE;						/* at least 8 bits signed		*/
typedef unsigned char	U_BYTE;						/* at least 8 bits unsigned		*/
typedef char			CHAR;						/* one signed character			*/
typedef unsigned char	U_CHAR;						/* one unsigned character		*/
typedef int				INT16;						/* at least 16 bits signed		*/
typedef unsigned int	U_INT16;					/* at least 16 bits unsigned	*/
typedef int				INT32;						/* 32 bits signed				*/
typedef	unsigned int	U_INT32;					/* 32 bits unsigned				*/
typedef double			DOUBLE;						/* 64 bits unsigned				*/

#define VARIABLE_ARRAY_SIZE	1
#define VAR_ARGS

typedef VOID			*POINTER;

#define MAXINTEGER		INT_MAX
#define MAXSHORT		SHORT_MAX

#define next_short(argp)	va_arg(argp,INT16)
#define next_string(argp)	va_arg(argp,CHAR *)

#endif

#define STRINGSIZE 256

typedef CHAR			SSTRING[STRINGSIZE+1];

#define true			((BOOL)-1)
#define false			((BOOL)0)

/************************************************************************************
 *																					*
 *		basic types (part 2)														*
 *																					*
 ************************************************************************************/

enum NODE_TYPE
{
	/* 8 bits free to store some node characteristics */
	
	NORMAL_NODE		=0,
	
	DEFERED_NODE	=1,			/* set if defered entry, not used anymore */
	RESERVED_NODE	=2,			/* set if entry for reserved node */
	UNUSED			=4,			/* formerly set if entry for copy node */
	CHANNEL_NODE	=8			/* set if entry for channel node */	
};

typedef enum LABEL_DATA
{
	/* defined data */
	
	D_NODATA,
	
	D_STRING,
	D_FLOAT,
	D_DESCRIPTOR,
	D_EXPRESSION,

	/* imported data */
	
	IMP_DESCRIPTOR
	
} LABEL_DATA;

typedef struct LABEL
{
	/* if used for stuff that is defined in this module, the first field points
	   to the data/code it defines:
	
	   - for data labels this points to a float, a string or a descriptor (a data field).
	     this is initialised in cgcode when the float, string, or descriptor
	     is defined.
	   - for expression labels this points to the expression this label
	     defines
	   - for other labels this will point to the instruction block that
	     follows. This is not used at the moment
	
	   for imported labels this field points to some additional data that is passed
	   when the label is imported. At the moment this is only used for descriptors:
	   - an ea_label that is associated with the descriptor.
	*/
	
	union {
		
		POINTER						any;
		
		/* defined data */
		
		struct	DFLOAT				*f;
		struct	DSTRING				*string;
		struct	DDESCRIPTOR			*descriptor;
		struct	TINSTRUCTION_NODE	*expression;
		struct	INSTRUCTION_BLOCK	*code;
		
		/* imported data */
		
		struct LABEL				*ea_label;

	} def;
	
	U_INT32 *					vector;
	U_INT32						small_vector;

	union {
		INT16	stack_size;			/* nr of a-parameters				*/
		INT16	n_locals;			/* nr of a-locals (needed for garb. collect		*/
	} a;
	
	union {
		INT16	stack_size;			/* nr of b-parameters				*/
		INT16	c_offset;			/* offset to top of c stack 		*/
	} b;

	CHAR *						name;	
	INT16						number;
	
	U_INT16						flags;
	U_BYTE						def_type;			/* kind of data that label defines */

	U_BYTE						entry_type;			/* used classification of node entries */

} LABEL;


typedef struct VIRTUAL_PARAMETER
{
	INT16	local;				/* the virtual local addressed */
	INT16	next_use;			/* the next insytuction that uses this instruction */
	BOOL	used;				/* true if used lateron */
	
} VIRTUAL_PARAMETER;

typedef struct VIRTUAL_FPARAMETER
{
	/* used for floating point parameters */
	
	VIRTUAL_PARAMETER	low;
	VIRTUAL_PARAMETER	high;
	
} VIRTUAL_FPARAMETER;

typedef union PARAMETER
{
		struct INSTRUCTION_NODE		*pointer;		/* used for parameters of graphs */
		struct TINSTRUCTION			*inline_block;	/* used for block of inline instructions */
		
		struct VIRTUAL_PARAMETER	*virtual;		/* used during local allocation */
		struct VIRTUAL_FPARAMETER	*fvirtual;		/* used during local allocation */
		
		LABEL *						label;
		INT32						int32;
		INT16						int16;

} PARAMETER;

typedef union FLOAT
{
	/* note order of high and low for current processor */
	
	DOUBLE	f;
	
	struct join
	{
		U_INT32	high;
		U_INT32	low;
	} join;

	struct bits
	{
		U_INT32 sign:1, exp:11, frac1:20;
		U_INT32 frac2;
	} bits;

} FLOAT;

typedef struct STRING
{
	INT16	length;
	CHAR	*string;
	
} STRING;

typedef struct DESCRIPTOR
{
	LABEL	*node_entry_label;		/* label of node entry	*/
	LABEL	*lazy_entry_label;		/* label of lazy entry	*/
	
	CHAR	*string;
	INT16	string_length;
	
	INT16	arity;
	
} DESCRIPTOR;

/************************************************************************************
 *																					*
 *		data, defined in this module												*
 *																					*
 ************************************************************************************/

typedef struct DFLOAT
{
	/* floats are ordered, to avoid generating double defs */
	
	struct DFLOAT	*left;
	struct DFLOAT	*right;
	LABEL			*label;
	FLOAT			f;
	
} DFLOAT;

typedef struct DSTRING
{
	/* strings are ordered, to avoid generating double defs */
	
	struct DSTRING	*left;
	struct DSTRING	*right;
	LABEL			*label;
	STRING			s;
	
} DSTRING;

typedef struct DDESCRIPTOR
{
	struct DDESCRIPTOR	*next;
	LABEL				*label;			/* label of descriptor itself */
	LABEL				*string_label;	/* label of string contained in descriptor */
	DESCRIPTOR			d;

} DDESCRIPTOR;

typedef struct DSYMBOL
{
	struct DSYMBOL	*next;
	LABEL			*label;

} DSYMBOL;

/************************************************************************************
 *																					*
 *		nodes																		*
 *																					*
 ************************************************************************************/

#define NO_PREF	-1				/* means: result may be stored in any free local */

typedef struct NODE_INFO
{
	/*	Extra fields for instruction nodes. At this moment this is used for
		create and fill nodes only.
		
		The descriptor fieldsremembers the descriptor label and is mainly
		used for set_defer (used on new nodes), so that the descriptor can be
		inserted before the new node entry.
		
		The node arity indicates the number of arguments of the actual node as
		opposed to the to the number of arguments of the node structure used by
		the compiler.
		
		The size field indicates the size of a closure with node arity zero. This is
		used for special large nodes, such as reserved nodes and channel nodes.
	*/
	
	LABEL	*descriptor;
	INT16	node_arity;
	INT16	node_size;
	
} NODE_INFO;

typedef struct INSTRUCTION_NODE
{	
	INT16						code;			/* code								*/
	INT16						arity;			/* arity							*/
	INT16						count;			/* reference count of node			*/
	INT16						used_mark;		/* for stack optimisations			*/

	INT16						uregs;			/* max use of registers				*/
	INT16						ufloat_regs;	/* max use of float registers		*/
	INT16	 					u_locals;		/* max use of locals				*/
	INT16						i_locals;		/* increase in local use			*/
	BOOL						save_result;	/* should result be saved ?			*/
	BOOL						order_left;		/* for dyadic nodes: left arg first	*/
	
	INT16						pref_local;		/* prefered local to put result in	*/
	NODE_INFO					*info;			/* extra info */
	
	PARAMETER					parameters[VARIABLE_ARRAY_SIZE];	/* parameters */

} INSTRUCTION_NODE;

typedef INSTRUCTION_NODE *INSTRUCTION_GRAPH;

/************************************************************************************
 *																					*
 *		instructions																*
 *																					*
 ************************************************************************************/

typedef struct INSTRUCTION
{
	struct INSTRUCTION *	next;
	struct INSTRUCTION *	prev;
	INT16					code;
	union PARAMETER			parameters[VARIABLE_ARRAY_SIZE];	/* arity is determined by code */

} INSTRUCTION;

typedef struct INSTRUCTION_GROUP
{
	/*	note that the first 3 field of a GROUP instruction are the same as
		a normal instruction, so they can be traversed as if they are normal
		instructions
	*/
	
	struct INSTRUCTION *		next;		/* next normal instruction */
	struct INSTRUCTION *		prev;		/* previous normal instruction */
	INT16						code;		/* GROUP */
	INT16						free;		/* regs free at this point */
	struct INSTRUCTION_GROUP *	next_group;	/* next group of instructions */
	struct INSTRUCTION_GROUP *	prev_group;	/* previous group of instructions */

} INSTRUCTION_GROUP;

/************************************************************************************
 *																					*
 *		stack types																	*
 *																					*
 ************************************************************************************/

typedef struct A_STACK
{
	struct A_STACK *	next;
	struct A_STACK *	next_block_element;

	INSTRUCTION_GRAPH	graph;
	INSTRUCTION_GRAPH	load_graph;
	
	INT16				offset;
	INT16				flags;
	
} A_STACK;

typedef struct B_STACK
{
	struct B_STACK *	next;
	struct B_STACK *	next_block_element;

	INSTRUCTION_GRAPH	graph;
	INSTRUCTION_GRAPH	load_graph;
	
	INT16 				offset;
	INT16				flags;
	
} B_STACK;

/************************************************************************************
 *																					*
 *		blocks																		*
 *																					*
 ************************************************************************************/

typedef struct BLOCK_GRAPH
{
	struct BLOCK_GRAPH *		previous;
	struct BLOCK_GRAPH *		next;
	
	/* stack simulation fields */
	
	INT16						begin_a_stack_size;			/* size of stacks */
	INT16						begin_b_stack_size;
	INT16						end_a_stack_size;
	INT16						end_b_stack_size;
	
	U_INT32 *					end_stack_vector;			/* b stack vector at end */
	U_INT32						small_end_stack_vector;
	U_INT32 *					begin_stack_vector;			/* b stack vector at begin */
	U_INT32						small_begin_stack_vector;
	
	struct A_STACK *			a_stack;					/* pointer to stack structure */
	INT16						a_stack_top_offset;			/* virtual offset of current stack top */
	INT16						a_stack_begin_displacement;	/* virtual offset-> real offset */
	INT16						a_stack_end_displacement;	/* virtual offset-> real offset */
	INT16						used_a_stack_elements;		/* no of parameters certainly used */
	
	struct B_STACK *			b_stack;					/* pointer to stack structure */
	INT16						b_stack_top_offset;			/* virtual offset of current stack top */
	INT16						b_stack_begin_displacement;	/* virtual offset-> real offset */
	INT16						b_stack_end_displacement;	/* virtual offset-> real offset */
	INT16						used_b_stack_elements;		/* no of parameters certainly used */
	
	INT16						begin_n_a_locals;			/* actual number of locals used */
	INT16						begin_n_b_locals;			/* actual number of locals used */
	INSTRUCTION_GRAPH			local_parameter_node[N_LOCALS];
	
	INT16						a_increase;					/* increase/decrease a stack */
	INT16						b_increase;					/* increase/decrease b stack */
	INT16						stack_use;					/* amount of stack space used by block */
	INT16						max_check_size;				/* maximal amount that may be checked earlier */

	/* entry fields */
	
	LABEL *						start_label;				/* label of this block */
	LABEL *						start_descriptor;			/* for node entries */
	INT16						start_arity;				/* for node entries */

	/* block kind */
	
	INT16						kind;
	
	/* param is used for inserted block that also have a parameter */
	
	union param
	{		
		LABEL *					label;				/* for jsr or gcall,		set by insert_label_layout_block */
		INT16					number;				/* for signals,				set by insert_layout_block */
		INT16					offset;				/* for jsr_eval or release,	set in evaluate_previous_blocks (offset on a-stack) */
	
		INSTRUCTION				*instruction;		/* after appending parameter instruction */
	
	} param;
		
	/* shared graphs */
	
	INSTRUCTION_GRAPH			a_stack_ptr;
	INSTRUCTION_GRAPH			b_stack_ptr;
	INSTRUCTION_GRAPH			heap_ptr;
	
	/* corresponding linearised block */
	
	struct INSTRUCTION_BLOCK	*instruction_block;
	
} BLOCK_GRAPH;

typedef struct BLOCK_DATA
{
	DSTRING		*first_string;
	DSTRING		*last_string;
	
	DFLOAT		*first_float;
	DFLOAT		*last_float;
	
	DSYMBOL		*first_symbol;
	DSYMBOL		*last_symbol;
	
} BLOCK_DATA;

typedef struct INSTRUCTION_BLOCK
{
	struct INSTRUCTION_BLOCK *	next;					/* ptr to next block */
	
	INSTRUCTION *				instructions;			/* first instruction */
	INSTRUCTION *				last_instruction;		/* last instruction */
	
	BLOCK_DATA *				data;					/* local data of block */
	LABEL *						start_label;			/* label of this block */
	
	LABEL *						node_descriptor;		/* desc label (for node entries) */
	INT16						node_arity;				/* arity for node entries */
	
	INT16						heap_use;				/* heap needed for this block */
	INT16						a_increase;				/* increase/decrease a stack */
	INT16						b_increase;				/* increase/decrease b stack */
	
	INT16						begin_n_a_locals;		/* no of ptrs in locals at start of block */
	INT16						begin_n_b_locals;		/* no of basic values in locals at start of block */
	INT16						check_size;				/* stack size to check (is NOT a_increase+b_increase) */
	
	BOOL						ready;					/* true if last_instr is last instruction indeed (except for inline instructions) */

} INSTRUCTION_BLOCK;

/************************************************************************************
 *																					*
 *			types for inline instructions											*
 *																					*
 ************************************************************************************/


typedef union TINSTRUCTION_PARAMETER
{	
	struct TINSTRUCTION_NODE	*pointer;
	
	CHAR						*literal;		/* literal value to print */
	LABEL						*label;			/* a label */
	STRING						*string;		/* output as "..." with escape sequences */
	
	INT32						number;			/* an integer (char/decimal/hexadecimal) constant or argument index */	
	
} TINSTRUCTION_PARAMETER;


typedef struct TINSTRUCTION_NODE
{
	INT16					kind;
	TINSTRUCTION_PARAMETER	parameter[VARIABLE_ARRAY_SIZE];
	
} TINSTRUCTION_NODE;


typedef struct TINSTRUCTION
{
	/* used for inline instructions and macro definitions */
	
	struct TINSTRUCTION			*next;				/* next instruction */
	struct TINSTRUCTION_DEF		*operator;			/* definition of instruction */
	
	TINSTRUCTION_NODE			*operand[VARIABLE_ARRAY_SIZE];
	
} TINSTRUCTION;


typedef struct TINSTRUCTION_DEF
{
	/* used to define inline instructions */
	
	CHAR			*name;							/* name of instruction */
	U_INT16			kind;							/* kind of instruction */
	
	VOID			(*parse) (struct TINSTRUCTION_DEF *instr);	/* for parsing this instruction */
	VOID			(*define) (struct TINSTRUCTION_DEF *instr);	/* for defining instruction in macro */

	U_INT16			arity;							/* arity of instruction */
	U_INT16			n_labels;						/* number of locally defined labels */
	TINSTRUCTION	*instructions;					/* def list of macro */

} TINSTRUCTION_DEF;

/************************************************************************************
 *																					*
 *		options																		*
 *																					*
 ************************************************************************************/

typedef enum ASSEMBLER_TYPE
{
	PARC_ASSEMBLER,
	PACT_ASSEMBLER
	
} ASSEMBLER_TYPE;

#ifdef MACINTOSH

typedef struct WindowPosition
{
	INT16	hpos;
	INT16	vpos;
	INT16	hsize;
	INT16	vsize;

} WindowPosition;

#endif

typedef struct OPTIONS
{
	/* options for code generation */
	
	U_INT16 max_errors;

	BOOL verbose_compile;
	BOOL verbose_warnings;
	BOOL verbose_errors;
	BOOL verbose_messages;
	
	BOOL parallel_code;
	BOOL inline_instructions;
	BOOL implicit_imports;
	BOOL ignore_depend;
	BOOL ignore_defer;
	
	BOOL output_full_label_names;
	BOOL output_debug_symbols;
	BOOL output_default_attributes;
	BOOL output_settings;
	
	BOOL output_intermediate_code1;
	BOOL output_intermediate_code2;
	BOOL output_intermediate_code3;
	
	ASSEMBLER_TYPE assembler;

	BOOL optimise_arith;
	BOOL optimise_jumps;
	BOOL optimise_a_stack;
	BOOL optimise_b_stack;
	BOOL optimise_a_parameter;
	BOOL optimise_stack_checks;
	
	BOOL any_proc_eval;
	BOOL poll_eval;

	BOOL check_stacks;
	BOOL check_arithmetic; 					/* not used */
	
	CHAR source_extension[5];
	CHAR assembly_extension[5];
	CHAR object_extension[5];				/* not used */
	
	CHAR intermediate_extension1[5];
	CHAR intermediate_extension2[5];
	CHAR intermediate_extension3[5];
	
	SSTRING source_directory;
	SSTRING depend_directory;
	SSTRING assembly_directory;
	SSTRING object_directory;				/* not used */

#ifdef MACINTOSH

	WindowPosition		graphics_position;
	WindowPosition		messages_position;
	WindowPosition		commands_position;

#endif

} OPTIONS;

#endif