#ifndef _CODE_
#define _CODE_

#ifndef _TYPES_
#include "cctypes.h"
#endif

extern VOID code_acosR				(VOID);
extern VOID code_addR				(VOID);
extern VOID code_asinR				(VOID);
extern VOID code_atanR				(VOID);
extern VOID code_cosR				(VOID);
extern VOID code_decR				(VOID);
extern VOID code_divR				(VOID);
extern VOID code_entierR			(VOID);
extern VOID code_eqR				(VOID);
extern VOID code_expR				(VOID);
extern VOID code_gtR				(VOID);
extern VOID code_incR				(VOID);
extern VOID code_lnR				(VOID);
extern VOID code_log10R				(VOID);
extern VOID code_ltR				(VOID);
extern VOID code_mulR				(VOID);
extern VOID code_powR				(VOID);
extern VOID code_remR				(VOID);
extern VOID code_sinR				(VOID);
extern VOID code_sqrtR				(VOID);

extern VOID code_addI				(VOID);
extern VOID code_andI				(VOID);
extern VOID code_andB				(VOID);
extern VOID code_decI				(VOID);
extern VOID code_divI				(VOID);
extern VOID code_eqI				(VOID);
extern VOID code_gtI				(VOID);
extern VOID code_incI				(VOID);
extern VOID code_ltI				(VOID);
extern VOID code_modI				(VOID);
extern VOID code_mulI				(VOID);
extern VOID code_notB				(VOID);
extern VOID code_notI				(VOID);
extern VOID code_orI				(VOID);
extern VOID code_orB				(VOID);
extern VOID code_randomI			(VOID);
extern VOID code_L_shiftl			(VOID);
extern VOID code_L_shiftr			(VOID);
extern VOID code_A_shiftl			(VOID);
extern VOID code_A_shiftr			(VOID);
extern VOID code_subI				(VOID);
extern VOID code_subR				(VOID);
extern VOID code_tanR				(VOID);
extern VOID code_xorI				(VOID);
extern VOID code_xorB				(VOID);

extern VOID code_CtoI				(VOID);
extern VOID code_ItoC				(VOID);
extern VOID code_ItoR				(VOID);
extern VOID code_RtoI				(VOID);

extern VOID code_catS				(INT16 source_offset_1,INT16 source_offset_2,INT16 destination_offset);
extern VOID code_cmpS				(INT16 a_offset_1,INT16 a_offset_2);
extern VOID code_indexS				(INT16 string_offset);
extern VOID code_lenS				(INT16 string_offset);
extern VOID code_sliceS				(INT16 source_offset,INT16 destination_offset);
extern VOID code_updateS			(INT16 source_offset,INT16 destination_offset);
extern VOID code_fillS_symbol		(INT16 a_offset_1,INT16 a_offset_2);

extern VOID code_pushI_a			(INT16 a_offset);
extern VOID code_pushF_a			(INT16 a_offset);
extern VOID code_pushR_a			(INT16 a_offset);
extern VOID code_pushI				(INT32 i);
extern VOID code_pushR				(FLOAT *r);

extern VOID code_push_a				(INT16 a_offset);
extern VOID code_push_b				(INT16 b_offset);
extern VOID code_pop_a				(INT16 n);
extern VOID code_pop_b				(INT16 n);
extern VOID code_cleanup_a			(INT16 n_elements,INT16 a_offset);
extern VOID code_cleanup_b			(INT16 n_elements,INT16 b_offset);
extern VOID code_update_a			(INT16 a_offset_1,INT16 a_offset_2);
extern VOID code_update_b			(INT16 b_offset_1,INT16 b_offset_2);

extern VOID code_push_node			(STRING *label_name,INT16 n_arguments);
extern VOID code_push_arg			(INT16 a_offset,INT16 arity,INT16 argument_number);
extern VOID code_push_arg_b			(INT16 a_offset);
extern VOID code_push_args			(INT16 a_offset,INT16 arity,INT16 n_arguments);
extern VOID code_repl_args			(INT16 arity,INT16 n_arguments);
extern VOID code_repl_arg			(INT16 arity,INT16 argument_n);
extern VOID code_repl_args_b		(VOID);

extern VOID code_endF				(VOID);
extern VOID code_getFC				(VOID);
extern VOID code_getFS				(INT16 string_offset);
extern VOID code_openF				(INT16 file_name_offset,INT16 file_type_offset);
extern VOID code_putFC				(VOID);
extern VOID code_putFS				(INT16 a_offset);
extern VOID code_reopenF			(VOID);

extern VOID code_create				(INT16 n);
extern VOID code_set_entry			(STRING *label_name,INT16 a_offset);

extern VOID code_fill				(STRING *desc_label,INT16 arity,STRING *code_name,INT16 offset);
extern VOID code_fillB				(INT32 value,INT16 a_offset);
extern VOID code_fillC				(INT32 value,INT16 a_offset);
extern VOID code_fillI				(INT32 value,INT16 a_offset);
extern VOID code_fillR				(FLOAT *value,INT16 a_offset);
extern VOID code_fillS				(STRING *string,INT16 a_offset);

extern VOID code_fillB_b			(INT16 b_offset,INT16 a_offset);
extern VOID code_fillC_b			(INT16 b_offset,INT16 a_offset);
extern VOID code_fillF_b			(INT16 b_offset,INT16 a_offset);
extern VOID code_fillI_b			(INT16 b_offset,INT16 a_offset);
extern VOID code_fillR_b			(INT16 b_offset,INT16 a_offset);
extern VOID code_fill_a				(INT16 from_offset,INT16 to_offset);

extern VOID code_eqI_a				(INT32 value,INT16 a_offset);
extern VOID code_eqI_b				(INT32 value,INT16 b_offset);
extern VOID code_eqR_a				(FLOAT *value,INT16 a_offset);
extern VOID code_eqR_b				(FLOAT *value,INT16 b_offset);
extern VOID code_eqS_a				(STRING *string,INT16 a_offset);

extern VOID code_eq_desc			(STRING *descriptor_name,INT16 arity,INT16 a_offset);
extern VOID code_eq_nulldesc		(STRING *descriptor_name,INT16 a_offset);
extern VOID code_eq_symbol			(INT16 a_offset_1,INT16 a_offset_2);
extern VOID code_get_desc_arity		(INT16 a_offset);
extern VOID code_get_node_arity		(INT16 a_offset);

extern VOID code_label				(STRING *label_name);
extern VOID code_jmp				(STRING *label_name);
extern VOID code_jmp_false			(STRING *label_name);
extern VOID code_jmp_true			(STRING *label_name);
extern VOID code_jsr_eval			(VOID);
extern VOID code_jmp_eval			(VOID);
extern VOID code_jmp_eval_upd		(VOID);

extern VOID code_o_label			(STRING *label,INT16 oa_size, INT16 ob_size, U_INT32 ovector[]);
extern VOID code_d_rtn				(INT16 da_size, INT16 db_size, U_INT32 dvector[]);
extern VOID code_d_jmp				(STRING *label, INT16 da_size, INT16 db_size, U_INT32 dvector[]);
extern VOID code_d_jsr_o			(STRING *label, INT16 da_size, INT16 db_size, U_INT32 dvector[],
									INT16 oa_size, INT16 ob_size, U_INT32 ovector[]);

extern VOID code_n_o_label			(STRING *label,INT16 arity,STRING *descriptor,STRING *ealabel, INT16 oa_size, INT16 ob_size, U_INT32 ovector[]);
extern VOID code_dump				(STRING *string);
extern VOID code_print				(STRING *string);
extern VOID code_print_sc			(STRING *string);
extern VOID code_print_symbol		(INT16 a_offset);
extern VOID code_print_symbol_sc	(INT16 a_offset);
extern VOID code_printD				(VOID);
extern VOID code_pushD				(STRING *descriptor);

extern VOID code_desc				(STRING *desc,STRING *node_entry,STRING *lazy_entry,INT16 arity,STRING *repr);
extern VOID code_export				(STRING *label_name);
extern VOID code_import				(STRING *label_name);
extern VOID code_impdesc			(STRING *desc_name, STRING *ealabel_name);
extern VOID code_start				(STRING *label_name);
extern VOID code_string				(STRING *label, STRING *string);
extern VOID code_keep				(INT16 a_offset_1,INT16 a_offset_2);

extern VOID code_set_defer			(INT16 a_offset);
extern VOID code_setwait			(INT16 a_offset);
extern VOID code_setfirstwait		(STRING *label_name,INT16 a_offset);
extern VOID code_getWL				(INT16 a_offset);
extern VOID code_putWL				(INT16 a_offset);
extern VOID code_releaseWL			(VOID);
extern VOID code_suspend			(VOID);
extern VOID code_suspend_uneval		(VOID);
extern VOID code_is_reserved		(INT16 a_offset);
extern VOID code_new_int_reducer	(STRING *label, INT16 a_offset);
extern VOID code_stop_reducer		(VOID);
extern VOID code_force_cs			(VOID);
extern VOID code_enable_cs			(VOID);
extern VOID code_disable_cs			(VOID);

extern VOID code_number_processors		(VOID);
extern VOID code_current_processor		(VOID);
extern VOID code_new_processor			(VOID);
extern VOID code_random_processor		(VOID);
extern VOID code_channel_processor		(INT16 a_offset);
extern VOID code_neighbour_processor	(VOID);
extern VOID code_ItoP					(VOID);
extern VOID code_distanceP				(VOID);

extern VOID code_create_channel		(STRING *code_label);
extern VOID code_send_graph			(STRING *code, INT16 graph_offset,INT16 channel_offset);

extern VOID code_halt				(VOID);
extern VOID code_no_op				(VOID);
extern VOID code_unimplemented		(VAR_ARGS);

extern VOID code_in (INT16 n_a_parameters, INT16 n_b_parameters, U_INT32 vector[],STRING *params);
extern VOID code_out (INT16 n_a_parameters, INT16 n_b_parameters, U_INT32 vector[],STRING *params);

extern BOOL code_d_begin_inline		(INT16 da_size, INT16 db_size, U_INT32 dvector[]);
extern VOID code_o_end_inline		(INT16 offered_a_stack_size,INT16 offered_b_stack_size, U_INT32 offered_vector[]);
extern VOID code_o					(INT16 offered_a_stack_size,INT16 offered_b_stack_size, U_INT32 offered_vector[]);

extern VOID code_entry_defer		(STRING *entry);
extern VOID code_entry_reserve		(STRING *entry);
extern VOID code_entry_copy			(STRING *entry);
extern VOID code_entry_channel		(STRING *entry);

extern VOID code_return_local		(STRING *label);

extern VOID initialize_coding (VOID);
extern INSTRUCTION_BLOCK *code_end (BOOL inline_end);

#endif
