#include "ifinterface.h"

#include "cgerror.h"

U_INT16 nr_errors;
U_INT16 nr_warnings;

/************************************************************************************
 *																					*
 *		some globally used error routines											*
 *																					*
 ************************************************************************************/

VOID fatal_error (CHAR *mess, ...)
{   va_list argp;
    va_start(argp, mess);
    verror(mess, argp);
    va_end(argp);
    abort_code_generation();
}

static void test_max_error()
{
    if(nr_errors < options.max_errors)
    	return;
    
    error("maximum number of errors reached, compilation aborted\n");
    abort_code_generation();
}

VOID label_error (LABEL *label,CHAR *mess, ...)
{	va_list argp;

	if (label->name!=NULL)
		error("\nLABEL ERROR (%s) ",label->name);
	else
		error("\nLABEL ERROR (?) ");
	
	va_start(argp,mess);
	verror(mess,argp);
	va_end(argp);
	error("\n");
	nr_errors++;
	
	test_max_error();
}
