#ifndef _SUPPORT_
#define _SUPPORT_

#ifndef _TYPES_
#include "cctypes.h"
#endif

extern U_INT16 nr_errors;
extern U_INT16 nr_warnings;

/* error messages */

VOID fatal_error	(CHAR *mess, ...);
VOID label_error	(LABEL *label,CHAR *mess, ...);

/* memory allocation */

extern POINTER alloc_heap_mem	(U_INT16 size);
extern POINTER alloc_graph_mem	(U_INT16 size);
extern POINTER alloc_block_mem	(U_INT16 size);
extern POINTER alloc_macro_mem	(U_INT16 size);

extern VOID free_graph_mem(VOID);
extern VOID free_block_mem(VOID);
extern VOID free_macro_mem(VOID);

extern CHAR *alloc_macro_string	(STRING *s);

extern CHAR		*new_chars_from_chars	(CHAR *s);
extern CHAR		*new_chars_from_string	(STRING *s);
extern STRING	*new_string_from_string (STRING *s);

extern VOID put_new_string_from_string (STRING *source, STRING *dest);

extern VOID alloc_code_memory(VOID);
extern VOID free_code_memory(VOID);

#endif