
#ifndef _STACKS_
#define _STACKS_

#ifndef _TYPES_
#include "cctypes.h"
#endif

extern U_INT32 e_vector[];
extern U_INT32 i_vector[];
extern U_INT32 i_i_vector[];
extern U_INT32 i_i_i_vector[];

/* stack manipulating functions */

extern INSTRUCTION_GRAPH	s_get_pop_b	(BLOCK_GRAPH *block_graph);
extern INSTRUCTION_GRAPH	s_get_pop_a	(BLOCK_GRAPH *block_graph);
extern VOID					s_push_b	(BLOCK_GRAPH *block_graph,INSTRUCTION_GRAPH graph);
extern VOID					s_push_a 	(BLOCK_GRAPH *block_graph,INSTRUCTION_GRAPH graph);
extern VOID					s_put_b		(BLOCK_GRAPH *block_graph,INT16 offset,INSTRUCTION_GRAPH graph);
extern VOID					s_put_a		(BLOCK_GRAPH *block_graph,INT16 offset,INSTRUCTION_GRAPH graph);
extern INSTRUCTION_GRAPH	s_get_b		(BLOCK_GRAPH *block_graph,INT16 offset);
extern INSTRUCTION_GRAPH	s_get_a 	(BLOCK_GRAPH *block_graph,INT16 offset);
extern VOID					s_pop_a		(BLOCK_GRAPH *block_graph);
extern VOID					s_pop_b		(BLOCK_GRAPH *block_graph);
extern VOID					s_pop_a_n	(BLOCK_GRAPH *block_graph,INT16 n);
extern VOID					s_pop_b_n	(BLOCK_GRAPH *block_graph,INT16 n);

/*	stack manipulation functions for floats: some of these are implemented as
	macros, except the ones that would depend on evaluation order of arguments
	in C (which is not defined), and the ones that could result in multiple
	generations of (argument) graphs */

extern INSTRUCTION_GRAPH	s_get_pop_float	(BLOCK_GRAPH *block_graph);
extern VOID					s_push_float	(BLOCK_GRAPH *block_graph,INSTRUCTION_GRAPH f);
extern VOID					s_put_float		(BLOCK_GRAPH *block_graph,INT16 offset,INSTRUCTION_GRAPH f);

#define s_get_float(b,offset)		g_fjoin(s_get_b((b),(offset)),s_get_b((b),(offset)+1))
#define s_pop_float(b)				s_pop_b_n((b),2)

extern VOID set_label_layout 		(LABEL *label,INT16 a_stack_size,INT16 b_stack_size,U_INT32 vector[]);

extern VOID insert_graph_in_b_stack (BLOCK_GRAPH *block_graph,INSTRUCTION_GRAPH graph,INT16 b_stack_size,U_INT32 *vector);

/* basic block routines */

extern BLOCK_GRAPH *begin_layout_block			(INT16 a_stack_size, INT16 b_stack_size, U_INT32 vector []);
extern BLOCK_GRAPH *begin_label_layout_block	(LABEL *label);

extern VOID insert_label_layout_block			(BLOCK_GRAPH *block_graph,INT16 kind,LABEL *label);
extern VOID insert_layout_block					(BLOCK_GRAPH *block_graph,INT16 kind,INT16 n,INT16 n_a_parameters,INT16 n_b_parameters,U_INT32 vector[]);
extern VOID insert_delay_layout_block			(BLOCK_GRAPH *block_graph,INT16 kind);
extern VOID insert_delay_layout_a_param_block	(BLOCK_GRAPH *block_graph,INT16 kind);

extern VOID end_layout_block					(BLOCK_GRAPH *block_graph,INT16 n_a_parameters,INT16 n_b_parameters,U_INT32 vector[]);
extern VOID end_label_layout_block				(BLOCK_GRAPH *block_graph,LABEL *label);
extern VOID end_graph_label_layout_block		(BLOCK_GRAPH *block_graph,INSTRUCTION_GRAPH graph,LABEL *label);
extern VOID end_dummy_block						(BLOCK_GRAPH *block_graph);
extern VOID end_dummy_label_block				(BLOCK_GRAPH *block_graph,LABEL *label);

extern VOID combine_stack_checks				(BLOCK_GRAPH *last_block_graph);

extern VOID initialise_stacks(VOID);

extern BOOL check_parameters (INT16 n_a_parameters, INT16 n_b_parameters, U_INT32 vector[], STRING *params);

#endif