
#ifndef _MACINTERFACE_
#define _MACINTERFACE_

#include <stdarg.h>

#ifndef _TYPES_
#include "cctypes.h"
#endif

/************************************************************************************
 *																					*
 *		some definitions for compatibility											*
 *																					*
 ************************************************************************************/

#include "ifwindows.h"

/************************************************************************************
 *																					*
 *		window id's																	*
 *																					*
 ************************************************************************************/

#define window_id_command			128
#define window_id_error				129
#define window_id_graphics			130

#define Cdialog_id_generate			128
#define Cdialog_id_generate_verbose	136

#define dialog_id_about				129
#define dialog_id_internal_error	130
#define dialog_id_optimisations		131
#define dialog_id_checks			132
#define dialog_id_assembly_format	133
#define dialog_id_abc_format		134
#define dialog_id_procesess			135
#define dialog_id_messages			137
#define dialog_id_paths				138

#define dialog_id_select			4000

/************************************************************************************
 *																					*
 *		menu id's																	*
 *																					*
 ************************************************************************************/

#define menu_id_apple					128
#define menu_id_file					129
#define menu_id_edit					130
#define menu_id_options					131
#define menu_id_remote					132
#define menu_id_window					133

#define menu_item_about					1

#define menu_item_quit					1

#define menu_item_undo					1
#define menu_item_cut					3
#define menu_item_copy					4
#define menu_item_paste					5
#define menu_item_clear					6

#define menu_item_processes				1
#define menu_item_optimisations			2
#define menu_item_checks				3
#define menu_item_input					5
#define menu_item_output				6
#define menu_item_messages				8
#define menu_item_paths					9

#define menu_item_force_disconnect		1
#define menu_item_remote_enable			2

#define menu_item_command_window		1
#define	menu_item_messages_window		2
#define menu_item_graphics_window		3

/********************************************************************************
 *																				*
 *		string id's																*
 *																				*
 ********************************************************************************/

#define string_id_enable				128
#define string_id_disable				129

/********************************************************************************
 *																				*
 *		pattern id's															*
 *																				*
 ********************************************************************************/

#define pattern_id_generate1			128
#define pattern_id_generate2			129

/********************************************************************************
 *																				*
 *		typedefs																*
 *																				*
 ********************************************************************************/

typedef struct Windows
{
	struct GraphWindow		command_window;
	struct GraphWindow		messages_window;
	struct GraphWindow		graphics_window;

	DialogPtr				generate_dialog;
	
} Windows;

typedef struct Menus
{
	MenuHandle				apple_menu;
	MenuHandle				file_menu;
	MenuHandle				edit_menu;
	MenuHandle				options_menu;
	MenuHandle				remote_menu;
	MenuHandle				window_menu;
	
} Menus;

typedef struct Strings
{
	StringHandle			enable_string;
	StringHandle			disable_string;
	
} Strings;

extern unsigned long	ticks_passed;

extern struct Strings	strings;
extern struct Windows	windows;
extern struct Menus		menus;

extern void		do_activate(EventRecord *event);
extern void		do_update(EventRecord *event);

#endif